--- xcommon.c.ori	2008-10-28 00:04:48.000000000 +0100
+++ xcommon.c	2008-11-03 17:09:40.000000000 +0100
@@ -1790,10 +1790,30 @@
         }
     } while( !( b_expose && b_configure_notify && b_map_notify ) );
 
-    XSelectInput( p_vout->p_sys->p_display, p_win->base_window,
-                  StructureNotifyMask | KeyPressMask |
-                  ButtonPressMask | ButtonReleaseMask |
-                  PointerMotionMask );
+    /* key and mouse events handling depending on --vout-x11-event parameter 
+     *      - activated by default
+     *      - desactivated if variable provided by user with value "none"
+     *      or value "fullscreen-only" and condition not met
+     */
+    char* psz_vout_x11_event = var_CreateGetString( p_vout, "vout-x11-event" );
+    bool  b_x11_event = 
+                  ( psz_vout_x11_event )
+                  &&
+                  (    ( !strcmp( psz_vout_x11_event, "none" ) )
+                    || ( !strcmp( psz_vout_x11_event, "fullscreen-only" ) && !p_vout->b_fullscreen ) 
+                  ) ? false : true;
+       
+    if ( psz_vout_x11_event )
+    {
+        msg_Dbg(p_vout,"vout-x11-event = %s",psz_vout_x11_event);
+        free( psz_vout_x11_event );
+    }
+
+    if ( b_x11_event )
+        XSelectInput( p_vout->p_sys->p_display, p_win->base_window,
+                      StructureNotifyMask | KeyPressMask |
+                      ButtonPressMask | ButtonReleaseMask |
+                      PointerMotionMask );
 
 #ifdef MODULE_NAME_IS_x11
     if( XDefaultDepth(p_vout->p_sys->p_display, p_vout->p_sys->i_screen) == 8 )
